package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.DESParameters;
import cn.com.infosec.crypto.params.DESedeParameters;

public class DESedeKeyGenerator extends DESKeyGenerator {
   public void init(KeyGenerationParameters param) {
      super.init(param);
      int param1;
      if ((param1 = super.strength) != 0 && param1 != 21) {
         if (param1 == 14) {
            super.strength = 16;
         } else if (param1 != 24 && param1 != 16) {
            throw new IllegalArgumentException("DESede key must be 192 or 128 bits long.");
         }
      } else {
         super.strength = 24;
      }

   }

   public byte[] generateKey() {
      int var1;
      byte[] var2 = new byte[var1 = super.strength];

      do {
         super.random.nextBytes(var2);
         DESParameters.setOddParity(var2);
      } while(DESedeParameters.isWeakKey(var2, 0, var1));

      return var2;
   }
}
